summaryrefslogtreecommitdiffstats
path: root/apps
diff options
context:
space:
mode:
authorMorris Jobke <hey@morrisjobke.de>2015-02-10 19:44:29 +0100
committerMorris Jobke <hey@morrisjobke.de>2015-02-10 19:53:01 +0100
commit10e91c6a481bc30f57a434c849e8f41c1b5e34ad (patch)
treec76e482608236b26b03393acb306190e164692f4 /apps
parent11283c57d9bba055e881293d6958ac9d6033f928 (diff)
downloadnextcloud-server-10e91c6a481bc30f57a434c849e8f41c1b5e34ad.tar.gz
nextcloud-server-10e91c6a481bc30f57a434c849e8f41c1b5e34ad.zip
[files_external] sftp tests
Diffstat (limited to 'apps')
-rw-r--r--apps/files_external/tests/backends/sftp.php8
-rwxr-xr-xapps/files_external/tests/env/start-sftp-atmoz.sh65
-rwxr-xr-xapps/files_external/tests/env/stop-sftp-atmoz.sh36
3 files changed, 105 insertions, 4 deletions
diff --git a/apps/files_external/tests/backends/sftp.php b/apps/files_external/tests/backends/sftp.php
index 703b37d93f1..1369580e916 100644
--- a/apps/files_external/tests/backends/sftp.php
+++ b/apps/files_external/tests/backends/sftp.php
@@ -29,12 +29,12 @@ class SFTP extends Storage {
parent::setUp();
$id = $this->getUniqueID();
- $this->config = include('files_external/tests/config.php');
- if ( ! is_array($this->config) or ! isset($this->config['sftp']) or ! $this->config['sftp']['run']) {
+ $this->config = include('files_external/tests/config.sftp.php');
+ if (!is_array($this->config) or !$this->config['run']) {
$this->markTestSkipped('SFTP backend not configured');
}
- $this->config['sftp']['root'] .= '/' . $id; //make sure we have an new empty folder to work in
- $this->instance = new \OC\Files\Storage\SFTP($this->config['sftp']);
+ $this->config['root'] .= '/' . $id; //make sure we have an new empty folder to work in
+ $this->instance = new \OC\Files\Storage\SFTP($this->config);
$this->instance->mkdir('/');
}
diff --git a/apps/files_external/tests/env/start-sftp-atmoz.sh b/apps/files_external/tests/env/start-sftp-atmoz.sh
new file mode 100755
index 00000000000..7fb379839ba
--- /dev/null
+++ b/apps/files_external/tests/env/start-sftp-atmoz.sh
@@ -0,0 +1,65 @@
+#!/bin/bash
+#
+# ownCloud
+#
+# This script start a docker container to test the files_external tests
+# against. It will also change the files_external config to use the docker
+# container as testing environment. This is reverted in the stop step.W
+#
+# Set environment variable DEBUG to print config file
+#
+# @author Morris Jobke
+# @copyright 2015 Morris Jobke <hey@morrisjobke.de>
+#
+
+if ! command -v docker >/dev/null 2>&1; then
+ echo "No docker executable found - skipped docker setup"
+ exit 0;
+fi
+
+echo "Docker executable found - setup docker"
+
+echo "Fetch recent atmoz/sftp docker image"
+docker pull atmoz/sftp
+
+# retrieve current folder to place the config in the parent folder
+thisFolder=`echo $0 | replace "env/start-sftp-atmoz.sh" ""`
+
+if [ -z "$thisFolder" ]; then
+ thisFolder="."
+fi;
+
+user=test
+password=12345
+
+container=`docker run -d atmoz/sftp $user:$password:1001`
+
+host=`docker inspect $container | grep IPAddress | cut -d '"' -f 4`
+
+cat > $thisFolder/config.sftp.php <<DELIM
+<?php
+
+return array(
+ 'run'=>true,
+ 'host'=>'$host',
+ 'user'=>'$user',
+ 'password'=>'$password',
+ 'root'=>'',
+);
+
+DELIM
+
+echo "sftp container: $container"
+
+# put container IDs into a file to drop them after the test run (keep in mind that multiple tests run in parallel on the same host)
+echo $container >> $thisFolder/dockerContainerAtmoz.$EXECUTOR_NUMBER.sftp
+
+if [ -n "$DEBUG" ]; then
+ cat $thisFolder/config.sftp.php
+ cat $thisFolder/dockerContainerAtmoz.$EXECUTOR_NUMBER.sftp
+fi
+
+# TODO find a way to determine the successful initialization inside the docker container
+echo "Waiting 5 seconds for sftp initialization ... "
+sleep 5
+
diff --git a/apps/files_external/tests/env/stop-sftp-atmoz.sh b/apps/files_external/tests/env/stop-sftp-atmoz.sh
new file mode 100755
index 00000000000..829855c807c
--- /dev/null
+++ b/apps/files_external/tests/env/stop-sftp-atmoz.sh
@@ -0,0 +1,36 @@
+#!/bin/bash
+#
+# ownCloud
+#
+# This script stops the docker container the files_external tests were run
+# against. It will also revert the config changes done in start step.
+#
+# @author Morris Jobke
+# @copyright 2015 Morris Jobke <hey@morrisjobke.de>
+#
+
+if ! command -v docker >/dev/null 2>&1; then
+ echo "No docker executable found - skipped docker stop"
+ exit 0;
+fi
+
+echo "Docker executable found - stop and remove docker containers"
+
+# retrieve current folder to remove the config from the parent folder
+thisFolder=`echo $0 | replace "env/stop-sftp-atmoz.sh" ""`
+
+if [ -z "$thisFolder" ]; then
+ thisFolder="."
+fi;
+
+# stopping and removing docker containers
+for container in `cat $thisFolder/dockerContainerAtmoz.$EXECUTOR_NUMBER.sftp`; do
+ echo "Stopping and removing docker container $container"
+ # kills running container and removes it
+ docker rm -f $container
+done;
+
+# cleanup
+rm $thisFolder/config.sftp.php
+rm $thisFolder/dockerContainerAtmoz.$EXECUTOR_NUMBER.sftp
+